<template>
  <div
    :class="{ 'contracts--only': fetchedContracts.length === 1 }"
    class="contracts"
  >
    <div
      class="contract-item"
      v-for="(item, index) in openedContracts"
      :key="item.tariffUuid"
    >
      <div class="contract-item-title">
        <div class="contract-item-desc">
          <ob-radio
            label="Договор"
            :valueInput="item.uuid"
            name="contract"
            :data-qa="'contract_' + index"
            v-model="contract"
            @change="$emit('contractChanged', item)"
          />
          <span class="number">{{ item.clientExternalNumber }}</span>
        </div>
        <obTooltip
          :content="`Договор ${item.number}. Нажмите, чтобы открыть в новой вкладке.`"
          position="top-end"
        >
          <i class="icon document" @click="openContractPage(item)"></i>
        </obTooltip>
      </div>     
    </div>
    <span
      class="expand-contracts"
      v-if="hiddenContracts.length && !contractsExpanded"
      @click="contractsExpanded = true"
    >
      Показать ещё {{ this.hiddenContracts.length }}
      <i class="icon chevron-down"></i>
    </span>
    <expand-transition>
      <div v-if="contractsExpanded">
        <div
          class="contract-item"
          v-for="(item, index) in hiddenContracts"
          :key="item.uuid"
        >
          <div class="contract-item-title">
            <div class="contract-item-desc">
              <ob-radio
                label="Договор"
                :valueInput="item.uuid"
                name="contract"
                :data-qa="'contract_' + index"
                v-model="contract"
                @change="$emit('contractChanged', item)"
              />
              <span class="number">{{ item.clientExternalNumber }}</span>
            </div>
            <obTooltip
              :content="`Договор ${item.number}. Нажмите, чтобы открыть в новой вкладке.`"
              position="top-end"
            >
              <i class="icon document" @click="openContractPage(item)"></i>
            </obTooltip>
          </div>
        </div>
        <span
          class="expand-contracts"
          v-if="contractsExpanded"
          @click="contractsExpanded = false"
        >
          Свернуть
          <i class="icon chevron-up"></i>
        </span>
      </div>
    </expand-transition>
  </div>
</template>

<script>
import obRadio from "common-components/src/obComponents/obRadio";
import expandTransition from "common-components/src/obComponents/obExpandTransition";
import obTooltip from "common-components/src/obComponents/obTooltip";
export default {
  name: "fetchedContracts",

  components: {
    obRadio,
    expandTransition,
    obTooltip
  },

  props: {
    fetchedContracts: {
      type: Array,
      required: true,
    },
  },

  data() {
    return {
      contract: null,
      contractsExpanded: false
    }
  },

  computed: {
    openedContracts() {
      if (this.fetchedContracts.length > 3) {
        const res = [...this.fetchedContracts];
        return res.splice(0, 3);
      }
      return this.fetchedContracts;
    },

    hiddenContracts() {
      if (this.fetchedContracts.length <= 3) {
        return [];
      }

      const res = [...this.fetchedContracts];
      return res.splice(3);
    },
  },

  methods: {
    openContractPage(item) {
      const { href } = this.$router.resolve(`/contract/${item.uuid}`);
      window.open(href, '_blank');
    },
    reset() {
      this.contract = null;
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";
@import "~common-components/src/static/css/variables";

.contract-item:not(:last-child) {
  margin-bottom: 10px;
}

.contract-item-desc {
  &::v-deep {
    .ob-radio-container label {
      @include font-mixin(16px, 24px, 400, $color-grey-label);

      span {
        margin-top: -2px;
      }
    }
  }
}

.number {
  padding-left: 23px;
  @include font-mixin(12px, 14px, 400, $color-grey-label);
}

.contract-item-title {
  display: flex;
  justify-content: space-between;
}

.expand-contracts {
  color: $color-blue-smalt;
  cursor: pointer;
}

::v-deep {
  .document {
      margin-top: 2px;
      position: relative;
      top: 5px;
      font-size: 15px;
      color: $color-blue-smalt;
    }
}
</style>